package de.twenty11.skysail.common.ext.dbviewer;

import org.restlet.resource.Delete;
import org.restlet.resource.Get;
import org.restlet.resource.Put;

import de.twenty11.skysail.common.forms.ConstraintViolations;
import de.twenty11.skysail.common.responses.FailureResponse;
import de.twenty11.skysail.common.responses.Response;
import de.twenty11.skysail.common.responses.SuccessResponse;

/**
 * Restful Http Service for single Connection.
 * 
 */
public interface RestfulConnection {

    /**
     * @return the associated connection
     */
    @Get
    public Response<ConnectionDetails> getConnection();

    /**
     * @param connection connection to update
     * @return a {@link SuccessResponse} or a {@link FailureResponse} with a {@link ConstraintViolations} payload.
     */
    @Put
    public Response<ConstraintViolations<ConnectionDetails>> updateConnection(ConnectionDetails connection);

    @Delete
    public Response<String> deleteConnection();

}
