package de.twenty11.skysail.common.ext.dbviewer;

import java.util.List;

import org.restlet.resource.Get;
import org.restlet.resource.Post;

import de.twenty11.skysail.common.forms.ConstraintViolations;
import de.twenty11.skysail.common.responses.FailureResponse;
import de.twenty11.skysail.common.responses.Response;
import de.twenty11.skysail.common.responses.SuccessResponse;

/**
 * Restful Http Service for Connections.
 * 
 */
public interface RestfulConnections {

    /**
     * Returns a skysail {@link Response} containing the list of available connections.
     * 
     * @return a skysail response.
     */
    @Get
    public Response<List<ConnectionDetails>> getConnections();

    /**
     * adds a connection to the list of managed connections.
     * 
     * @param entity connection to add
     * @return a {@link SuccessResponse} or a {@link FailureResponse} with a {@link ConstraintViolations} payload.
     */
    @Post()
    public Response<ConstraintViolations<ConnectionDetails>> addConnection(ConnectionDetails entity);

}
